use inc::Module::Install;

perl_version '5.008008';


name 'make-world';
license 'gpl3';

all_from 'src/make-world';


requires 'Cwd';
requires 'File::Copy';
requires 'File::Path';
requires 'File::pushd';
requires 'File::Temp';
requires 'File::Spec::Functions';
requires 'Pod::Perldoc';
requires 'YAML::Tiny';
requires 'XML::Tiny';
requires 'Capture::Tiny';
requires 'version' => 0.77;
requires 'Archive::Extract';
requires 'File::Copy::Recursive';
requires 'IPC::Cmd' => 0.64;
requires 'Module::Load';
requires 'String::Interpolate::Shell';
requires 'Getopt::Long' => 2.36;
requires 'Moo';

test_requires 'Test::More';

recommends 'Getopt::ArgvFile';

author_requires 'Test::Pod';
author_requires 'Test::Strict';

unless ( grep { /--no-bundle/ } @ARGV  ) {
    bundle_deps( 'Moo' );
    bundle_deps( 'Test::Fatal' );
    bundle 'IPC::Cmd';
    bundle 'version';
    bundle 'Test::More';
    bundle 'XML::Tiny';
    bundle 'YAML::Tiny';
    bundle 'Capture::Tiny';
    bundle 'Template::Tiny';
    bundle 'Locale::Maketext::Simple';
    bundle 'Params::Check';
    bundle 'Archive::Extract';
    bundle 'File::Copy::Recursive';
    bundle 'File::pushd';
    bundle 'String::Interpolate::Shell';
    bundle 'Getopt::Long';
}


# can't bundle Getopt::ArgvFile because of behavior of Test::Pod
# when there's no lib or blib directories to search for pod source
# bundle 'Getopt::ArgvFile';

install_script 'src/make-world';

template_install_path();

use Cwd;
use File::Spec::Functions qw[ catdir ];

my $cwd = getcwd;

makemaker_args(
	 INST_ARCHLIB => catdir( $cwd, qw[ blib arch] ),
	 INST_LIB     => catdir( $cwd, qw[ blib lib] ),
	 INST_BIN     => catdir( $cwd, qw[ blib bin] ),
	 INST_SCRIPT  => catdir( $cwd, qw[ blib script] ),
	 INST_MAN1DIR => catdir( $cwd, qw[ blib man1] ),
	 INST_MAN3DIR => catdir( $cwd, qw[ blib man3] ),
	 );

WriteAll;
