package MakeWorld::Mogrify;

use strict;
use warnings;

use Module::Pluggable require => 1, search_path => qw[ MakeWorld::Mogrify ];

my @modules = __PACKAGE__->plugins();

my %Module = map { my $module = $_;
		$module =~ s/^.*:://;
		( lc($module) => $_ ) } @modules;


################################################################################
# does the command exist?
sub is_cmd { return $Module{$_[0]} }


################################################################################
# validate that the requested hook is legit.  called after a package has been
# specialized

sub validate {

    my $self = shift;
    my $mogrify = shift;

    my ( $stage, $location ) = $self->{stage}->parse_hook( $mogrify->{hook} );

    die( "invalid hook attribute value for $mogrify->{cmd}: $mogrify->{hook}\n" )
	unless $self->{stage}->is_legal_hook( $mogrify->{hook} );

    push @{ $self->{hook}{$stage}{$location} }, [ @{$mogrify}{ qw[ cmd action ] } ];

}

1;
