package MakeWorld::Mogrify::Exec;

use strict;
use warnings;

use MakeWorld::Utils qw[ find_exe ];
use MakeWorld::Check qw[ check ];
use MakeWorld::Run;
use MakeWorld::Log;

################################################################################
# execute a command

sub verify {

    my ( $class, $opts, $need_hook ) = @_;

    return check( { exe => { required => 1 },
		    arg => { default => [] },
		    hook => { required => $need_hook },
		  }, $opts );
}

sub mogrify
{
    my ( $class, $pkg, $opt ) = @_;

    my $arg = $opt->{arg};
    my $exe = $opt->{exe};
    my $file = eval { find_exe( $exe ) };

    unless ( $file )
    {
	return if $opt->{optional};
	die "exec: $exe: non-existent or non-executable file\n";
    }

    my @cmd = ( $file, $arg );

    msgp( "<exec>", MakeWorld::Log::Info, @cmd );

    run( @cmd )
	or die( "error running $exe\n" );

    return;
}

1;
